#**************************************************************
# Create Clock
#**************************************************************
derive_pll_clocks
derive_clock_uncertainty
 
create_clock -name {clk_fpga_p} -period 10.000 -waveform {0 5} {clk_fpga_p}
create_clock -name {altera_reserved_tck} -period 41.667 [get_ports { altera_reserved_tck }]

#**************************************************************
# Create Generated Clock
#**************************************************************
#create_generated_clock -name {clk_50m} -source [get_nets {sys_pll_inst|iopll_0|outclk_0}] 
create_generated_clock -name {clk_50m} -source [get_nets {sys_pll_inst|iopll_0|tennm_ph2_iopll~O_OUT_CLK0}]


#**************************************************************
# Set Clock Latency
#**************************************************************

#**************************************************************
# Set Clock Uncertainty
#**************************************************************

#**************************************************************
# Set Input Delay
#**************************************************************
set_input_delay -clock altera_reserved_tck 6 [get_ports altera_reserved_tdi]
set_input_delay -clock altera_reserved_tck 6 [get_ports altera_reserved_tms]

set_input_delay  -clock { clk_50m } 5   [get_ports {fmc_scl}]
set_input_delay  -clock { clk_50m } 5   [get_ports {fmc_sda}]
set_output_delay -clock { clk_50m } 2.5 [get_ports {fmc_scl}]
set_output_delay -clock { clk_50m } 2.5 [get_ports {fmc_sda}]

set_input_delay  -clock { clk_50m } 5   [get_ports {cxl_sda}]
set_input_delay  -clock { clk_50m } 5   [get_ports {cxl_scl}]
set_output_delay -clock { clk_50m } 2.5 [get_ports {cxl_sda}]
set_output_delay -clock { clk_50m } 2.5 [get_ports {cxl_scl}]

set_input_delay  -clock { clk_50m } 5   [get_ports {qsfp_sda}]
set_input_delay  -clock { clk_50m } 5   [get_ports {qsfp_scl}]
set_output_delay -clock { clk_50m } 2.5 [get_ports {qsfp_sda}]
set_output_delay -clock { clk_50m } 2.5 [get_ports {qsfp_scl}]

set_input_delay  -clock { clk_50m } 5   [get_ports {rdimm_i2c_sda}]
set_input_delay  -clock { clk_50m } 5   [get_ports {rdimm_i2c_scl}]
set_output_delay -clock { clk_50m } 2.5 [get_ports {rdimm_i2c_sda}]
set_output_delay -clock { clk_50m } 2.5 [get_ports {rdimm_i2c_scl}]

#**************************************************************
# Set Output Delay
#**************************************************************
set_output_delay -clock altera_reserved_tck -clock_fall -max 6 [get_ports altera_reserved_tdo]

#**************************************************************
# Set Clock Groups
#**************************************************************
set_clock_groups -asynchronous -group [get_clocks {altera_reserved_tck}]  
set_clock_groups -asynchronous -group [get_clocks {clk_fpga_p}]

#**************************************************************
# Set False Path
#**************************************************************
set_false_path -from [get_ports {fpga_resetn}] -to * 
set_false_path -from [get_ports {qsfpdd0_modprs_n}] -to * 
set_false_path -from [get_ports {qsfpdd1_modprs_n}] -to * 
set_false_path -from [get_ports {qsfpdd800_modprs_n}] -to * 
set_false_path -from [get_ports {si5392_lolb}] -to * 
set_false_path -from [get_ports {qsfpdd0_int_n}] -to * 
set_false_path -from [get_ports {qsfpdd1_int_n}] -to * 
set_false_path -from [get_ports {qsfpdd800_int_n}] -to *

set_false_path -from * -to [get_ports {qsfpdd0_modsel_n}]  
set_false_path -from * -to [get_ports {qsfpdd0_reset_n}]  
set_false_path -from * -to [get_ports {qsfpdd1_modsel_n}] 
set_false_path -from * -to [get_ports {qsfpdd1_reset_n}]  
set_false_path -from * -to [get_ports {qsfpdd800_modsel_n}] 
set_false_path -from * -to [get_ports {qsfpdd800_reset_n}] 
set_false_path -from * -to [get_ports {fpga_led0}]  
set_false_path -from * -to [get_ports {fpga_led1}]  
set_false_path -from * -to [get_ports {fpga_led2}]  
set_false_path -from * -to [get_ports {fpga_led3}]  
set_false_path -from * -to [get_ports {qsfpdd0_led0}]   
set_false_path -from * -to [get_ports {qsfpdd0_led1}] 
set_false_path -from * -to [get_ports {qsfpdd1_led0}]   
set_false_path -from * -to [get_ports {qsfpdd1_led1}]
set_false_path -from * -to [get_ports {qsfpdd800_led0}]   
set_false_path -from * -to [get_ports {qsfpdd800_led1}]
set_false_path -from * -to [get_ports {qsfpdd0_lpmode}]   
set_false_path -from * -to [get_ports {qsfpdd1_lpmode}]
set_false_path -from * -to [get_ports {qsfpdd800_lpmode}]   
set_false_path -from * -to [get_ports {si5518_rstn}]
set_false_path -from * -to [get_ports {sdi_clk148_5m_up}]  
set_false_path -from * -to [get_ports {sdi_clk148_5m_down}]  

#**************************************************************
# Set Multicycle Path
#**************************************************************


#**************************************************************
# Set Maximum Delay
#**************************************************************


#**************************************************************
# Set Minimum Delay
#**************************************************************



#**************************************************************
# Set Input Transition
#**************************************************************