
module bts_ddr5 (    
		input  wire        ref_clk_0_clk,                //        ref_clk_0.clk
		output wire        emif_ph2_0_mem_0_mem_ck_t,    // emif_ph2_0_mem_0.mem_ck_t
		output wire        emif_ph2_0_mem_0_mem_ck_c,    //                 .mem_ck_c
		output wire        emif_ph2_0_mem_0_mem_reset_n, //                 .mem_reset_n
		output wire        emif_ph2_0_mem_0_mem_cs_n,    //                 .mem_cs_n
		output wire [12:0] emif_ph2_0_mem_0_mem_ca,      //                 .mem_ca
		inout  wire [31:0] emif_ph2_0_mem_0_mem_dq,      //                 .mem_dq
		inout  wire [3:0]  emif_ph2_0_mem_0_mem_dqs_t,   //                 .mem_dqs_t
		inout  wire [3:0]  emif_ph2_0_mem_0_mem_dqs_c,   //                 .mem_dqs_c
		output wire [3:0]  emif_ph2_0_mem_0_mem_dm_n,    //                 .mem_dm_n
		input  wire        emif_ph2_0_mem_0_mem_alert_n, //                 .mem_alert_n
		input  wire        emif_ph2_0_oct_0_oct_rzqin,   // emif_ph2_0_oct_0.oct_rzqin
		input  wire        noc_ctrl_refclk_clk,          //  noc_ctrl_refclk.clk
		input  wire        ref_clk_usr_pll_clk           //  ref_clk_usr_pll.clk
	);

//--------------------------------------------------------------------------------------------------------------------------
wire          ninit_done     ;	  

  ed_synth u0 (
		.ref_clk_0_clk                (ref_clk_0_clk),                //   input,   width = 1,        ref_clk_0.clk
		.emif_ph2_0_mem_0_mem_ck_t    (emif_ph2_0_mem_0_mem_ck_t),    //  output,   width = 1, emif_ph2_0_mem_0.mem_ck_t
		.emif_ph2_0_mem_0_mem_ck_c    (emif_ph2_0_mem_0_mem_ck_c),    //  output,   width = 1,                 .mem_ck_c
		.emif_ph2_0_mem_0_mem_reset_n (emif_ph2_0_mem_0_mem_reset_n), //  output,   width = 1,                 .mem_reset_n
		.emif_ph2_0_mem_0_mem_cs_n    (emif_ph2_0_mem_0_mem_cs_n),    //  output,   width = 1,                 .mem_cs_n
		.emif_ph2_0_mem_0_mem_ca      (emif_ph2_0_mem_0_mem_ca),      //  output,  width = 13,                 .mem_ca
		.emif_ph2_0_mem_0_mem_dq      (emif_ph2_0_mem_0_mem_dq),      //   inout,  width = 32,                 .mem_dq
		.emif_ph2_0_mem_0_mem_dqs_t   (emif_ph2_0_mem_0_mem_dqs_t),   //   inout,   width = 4,                 .mem_dqs_t
		.emif_ph2_0_mem_0_mem_dqs_c   (emif_ph2_0_mem_0_mem_dqs_c),   //   inout,   width = 4,                 .mem_dqs_c
		.emif_ph2_0_mem_0_mem_dm_n    (emif_ph2_0_mem_0_mem_dm_n),    //  output,   width = 4,                 .mem_dm_n
		.emif_ph2_0_mem_0_mem_alert_n (emif_ph2_0_mem_0_mem_alert_n), //   input,   width = 1,                 .mem_alert_n
		.emif_ph2_0_oct_0_oct_rzqin   (emif_ph2_0_oct_0_oct_rzqin),   //   input,   width = 1, emif_ph2_0_oct_0.oct_rzqin
		.noc_ctrl_refclk_clk          (noc_ctrl_refclk_clk),          //   input,   width = 1,  noc_ctrl_refclk.clk
		.ninit_done_reset             (ninit_done),             //  output,   width = 1,       ninit_done.reset		
		.ref_clk_usr_pll_clk          (ref_clk_usr_pll_clk)           //   input,   width = 1,  ref_clk_usr_pll.clk
  );

  q_sys q_sys_inst(                                                               
		.clk_clk                                     (ref_clk_usr_pll_clk),                                     //   input,   width = 1,                                  clk.clk
		.reset_n_reset_n                             (!ninit_done)
  );					     

endmodule	
	