
module hbm2e_top (    
  input  wire          core_pll_refclk_clk   ,    // system clock, 100M
  input  wire       uibpll_refclk_clk           ,   
  input  wire       noc_clk_ctrl_refclk_clk ,
  input wire        hbm_cattrip_virtual,
  input  wire [2:0] hbm_temp_virtual

);

//--------------------------------------------------------------------------------------------------------------------------
wire          ninit_done     ;	
wire          S_global_resetn;	  
wire          clk_70m        ;  
//reg  [27:0]   heart_beat_cnt/* synthesis keep */;
wire [7:0]    S_local_cal;
wire          local_cal_success;
wire          local_cal_fail;
wire          noc_pll_lock;
wire          core_pll_lock;
wire          hbm_reset_in_prog;
wire          global_user_reset_n;
wire          hbm_only_reset;
   
assign S_global_resetn = !ninit_done && core_pll_lock; //NINIT_DONE is high until the entire device enters user mode

 ed_synth u0 (
        .clk_70m_clk                                            (clk_70m),
		.core_pll_refclk_clk                                    (core_pll_refclk_clk),                                    //   input,  width = 1,                             core_pll_refclk.clk
		.core_pll_locked_export                                 (core_pll_lock),                                 //  output,  width = 1,                      core_pll_locked.export
		.global_user_reset_handler_conduit_0_export             (core_pll_lock),             //   input,  width = 1,  global_user_reset_handler_conduit_0.export
		.global_user_reset_extender_conduit_0_local_cal_success (local_cal_success), //   input,  width = 1,        global_user_reset_extender_conduit_0.local_cal_success
		.global_user_reset_reset_n                              (global_user_reset_n),                              //   input,  width = 1,                           global_user_reset.reset_n
		.hbm_fp_0_hbm_reset_in_prog_hbm_reset_in_prog           (hbm_reset_in_prog),           //  output,  width = 1,                  hbm_fp_0_hbm_reset_in_prog.hbm_reset_in_prog
		.hbm_cattrip_virtual_i_conduit                          (hbm_cattrip_virtual),                          //   input,  width = 1,                       hbm_cattrip_virtual_i.conduit
		.hbm_temp_virtual_i_conduit                             (hbm_temp_virtual),                             //   input,  width = 3,                          hbm_temp_virtual_i.conduit
		.hbm_fp_0_local_cal_success_local_cal_success           (local_cal_success),           //  output,  width = 1,                  hbm_fp_0_local_cal_success.local_cal_success
		.hbm_fp_0_local_cal_fail_local_cal_fail                 (local_cal_fail ),                 //  output,  width = 1,                     hbm_fp_0_local_cal_fail.local_cal_fail
		.uibpll_refclk_clk                                      (uibpll_refclk_clk),                                      //   input,  width = 1,                               uibpll_refclk.clk
		.hbm_only_reset_reset                                   (hbm_only_reset),                                   //   input,  width = 1,                              hbm_only_reset.reset
		.noc_clk_ctrl_refclk_clk                                (noc_clk_ctrl_refclk_clk),                                //   input,  width = 1,                         noc_clk_ctrl_refclk.clk
		.noc_clock_ctrl_0_pll_lock_o_pll_lock_o                 (noc_pll_lock),                 //  output,  width = 1,                 noc_clock_ctrl_0_pll_lock_o.pll_lock_o
		.ninit_done_reset      (ninit_done)       //  output,  width = 1, post_configuration_reset_release_ninit_done.reset
	);
 
  assign S_local_cal = {1'd0,hbm_only_reset, global_user_reset_n, core_pll_lock, hbm_reset_in_prog, noc_pll_lock, local_cal_fail, local_cal_success};
  q_sys q_sys_inst(                                                               
		.clk_clk                                     (clk_70m               ),                                     //   input,   width = 1,                                  clk.clk
		.reset_n_reset_n                             (S_global_resetn       ),                               //   input,   width = 1,                                reset.reset_n
		.pio_0_external_connection_export            (S_local_cal       ),                     //   input,  width = 8, pio_0_external_connection.export
        .pio_1_external_connection_export            ({hbm_only_reset, global_user_reset_n}) //  output,  width = 1, pio_1_external_connection.export
);					     

endmodule	
	