
module bts_lpddr5 (    
		input  wire        ref_clk_0_clk,                //        ref_clk_0.clk
		output wire        emif_ph2_0_mem_0_mem_ck_t,    // emif_ph2_0_mem_0.mem_ck_t
		output wire        emif_ph2_0_mem_0_mem_ck_c,    //                 .mem_ck_c
		output wire        emif_ph2_0_mem_0_mem_reset_n, //                 .mem_reset_n
		output wire        emif_ph2_0_mem_0_mem_cs,      //                 .mem_cs
		output wire [6:0]  emif_ph2_0_mem_0_mem_ca,      //                 .mem_ca
		inout  wire [15:0] emif_ph2_0_mem_0_mem_dq,      //                 .mem_dq
		output wire [1:0]  emif_ph2_0_mem_0_mem_wck_t,   //                 .mem_wck_t
		output wire [1:0]  emif_ph2_0_mem_0_mem_wck_c,   //                 .mem_wck_c
		inout  wire [1:0]  emif_ph2_0_mem_0_mem_rdqs_t,  //                 .mem_rdqs_t
		inout  wire [1:0]  emif_ph2_0_mem_0_mem_rdqs_c,  //                 .mem_rdqs_c
		inout  wire [1:0]  emif_ph2_0_mem_0_mem_dmi,     //                 .mem_dmi
		output wire        emif_ph2_0_mem_1_mem_ck_t,    // emif_ph2_0_mem_1.mem_ck_t
		output wire        emif_ph2_0_mem_1_mem_ck_c,    //                 .mem_ck_c
		output wire        emif_ph2_0_mem_1_mem_cs,      //                 .mem_cs
		output wire [6:0]  emif_ph2_0_mem_1_mem_ca,      //                 .mem_ca
		inout  wire [15:0] emif_ph2_0_mem_1_mem_dq,      //                 .mem_dq
		output wire [1:0]  emif_ph2_0_mem_1_mem_wck_t,   //                 .mem_wck_t
		output wire [1:0]  emif_ph2_0_mem_1_mem_wck_c,   //                 .mem_wck_c
		inout  wire [1:0]  emif_ph2_0_mem_1_mem_rdqs_t,  //                 .mem_rdqs_t
		inout  wire [1:0]  emif_ph2_0_mem_1_mem_rdqs_c,  //                 .mem_rdqs_c
		inout  wire [1:0]  emif_ph2_0_mem_1_mem_dmi,     //                 .mem_dmi
		input  wire        emif_ph2_0_oct_0_oct_rzqin,   // emif_ph2_0_oct_0.oct_rzqin
		input  wire        emif_ph2_0_oct_1_oct_rzqin,   // emif_ph2_0_oct_1.oct_rzqin
		input  wire        noc_ctrl_refclk_clk,          //  noc_ctrl_refclk.clk
		output wire        ninit_done_reset,             //       ninit_done.reset
		input  wire        ref_clk_usr_pll_clk           //  ref_clk_usr_pll.clk
	);
	
//--------------------------------------------------------------------------------------------------------------------------
wire          ninit_done     ;	
	
	ed_synth u0 (
		.ref_clk_0_clk                (ref_clk_0_clk),                //   input,   width = 1,        ref_clk_0.clk
		.emif_ph2_0_mem_0_mem_ck_t    (emif_ph2_0_mem_0_mem_ck_t),    //  output,   width = 1, emif_ph2_0_mem_0.mem_ck_t
		.emif_ph2_0_mem_0_mem_ck_c    (emif_ph2_0_mem_0_mem_ck_c),    //  output,   width = 1,                 .mem_ck_c
		.emif_ph2_0_mem_0_mem_reset_n (emif_ph2_0_mem_0_mem_reset_n), //  output,   width = 1,                 .mem_reset_n
		.emif_ph2_0_mem_0_mem_cs      (emif_ph2_0_mem_0_mem_cs),      //  output,   width = 1,                 .mem_cs
		.emif_ph2_0_mem_0_mem_ca      (emif_ph2_0_mem_0_mem_ca),      //  output,   width = 7,                 .mem_ca
		.emif_ph2_0_mem_0_mem_dq      (emif_ph2_0_mem_0_mem_dq),      //   inout,  width = 16,                 .mem_dq
		.emif_ph2_0_mem_0_mem_wck_t   (emif_ph2_0_mem_0_mem_wck_t),   //  output,   width = 2,                 .mem_wck_t
		.emif_ph2_0_mem_0_mem_wck_c   (emif_ph2_0_mem_0_mem_wck_c),   //  output,   width = 2,                 .mem_wck_c
		.emif_ph2_0_mem_0_mem_rdqs_t  (emif_ph2_0_mem_0_mem_rdqs_t),  //   inout,   width = 2,                 .mem_rdqs_t
		.emif_ph2_0_mem_0_mem_rdqs_c  (emif_ph2_0_mem_0_mem_rdqs_c),  //   inout,   width = 2,                 .mem_rdqs_c
		.emif_ph2_0_mem_0_mem_dmi     (emif_ph2_0_mem_0_mem_dmi),     //   inout,   width = 2,                 .mem_dmi
		.emif_ph2_0_mem_1_mem_ck_t    (emif_ph2_0_mem_1_mem_ck_t),    //  output,   width = 1, emif_ph2_0_mem_1.mem_ck_t
		.emif_ph2_0_mem_1_mem_ck_c    (emif_ph2_0_mem_1_mem_ck_c),    //  output,   width = 1,                 .mem_ck_c
		.emif_ph2_0_mem_1_mem_cs      (emif_ph2_0_mem_1_mem_cs),      //  output,   width = 1,                 .mem_cs
		.emif_ph2_0_mem_1_mem_ca      (emif_ph2_0_mem_1_mem_ca),      //  output,   width = 7,                 .mem_ca
		.emif_ph2_0_mem_1_mem_dq      (emif_ph2_0_mem_1_mem_dq),      //   inout,  width = 16,                 .mem_dq
		.emif_ph2_0_mem_1_mem_wck_t   (emif_ph2_0_mem_1_mem_wck_t),   //  output,   width = 2,                 .mem_wck_t
		.emif_ph2_0_mem_1_mem_wck_c   (emif_ph2_0_mem_1_mem_wck_c),   //  output,   width = 2,                 .mem_wck_c
		.emif_ph2_0_mem_1_mem_rdqs_t  (emif_ph2_0_mem_1_mem_rdqs_t),  //   inout,   width = 2,                 .mem_rdqs_t
		.emif_ph2_0_mem_1_mem_rdqs_c  (emif_ph2_0_mem_1_mem_rdqs_c),  //   inout,   width = 2,                 .mem_rdqs_c
		.emif_ph2_0_mem_1_mem_dmi     (emif_ph2_0_mem_1_mem_dmi),     //   inout,   width = 2,                 .mem_dmi
		.emif_ph2_0_oct_0_oct_rzqin   (emif_ph2_0_oct_0_oct_rzqin),   //   input,   width = 1, emif_ph2_0_oct_0.oct_rzqin
		.emif_ph2_0_oct_1_oct_rzqin   (emif_ph2_0_oct_1_oct_rzqin),   //   input,   width = 1, emif_ph2_0_oct_1.oct_rzqin
		.noc_ctrl_refclk_clk          (noc_ctrl_refclk_clk),          //   input,   width = 1,  noc_ctrl_refclk.clk
		.ninit_done_reset             (ninit_done),             //  output,   width = 1,       ninit_done.reset
		.ref_clk_usr_pll_clk          (ref_clk_usr_pll_clk)           //   input,   width = 1,  ref_clk_usr_pll.clk
	);
 
  q_sys q_sys_inst(                                                               
		.clk_clk                                     (ref_clk_usr_pll_clk),                                     //   input,   width = 1,                                  clk.clk
		.reset_n_reset_n                             (!ninit_done)
  );					     

endmodule	
	