# (C) 2001-2024 Intel Corporation. All rights reserved.
# Your use of Intel Corporation's design tools, logic functions and other 
# software and tools, and its AMPP partner logic functions, and any output 
# files from any of the foregoing (including device programming or simulation 
# files), and any associated documentation or information are expressly subject 
# to the terms and conditions of the Intel Program License Subscription 
# Agreement, Intel FPGA IP License Agreement, or other applicable 
# license agreement, including, without limitation, that your use is for the 
# sole purpose of programming logic devices manufactured by Intel and sold by 
# Intel or its authorized distributors.  Please refer to the applicable 
# agreement for further details.



set ::syn_flow 0
set ::sta_flow 0
set ::fit_flow 0
set ::pow_flow 0

if { $::TimeQuestInfo(nameofexecutable) == "quartus_map" || $::TimeQuestInfo(nameofexecutable) == "quartus_syn" } {
    set ::syn_flow 1
} elseif { $::TimeQuestInfo(nameofexecutable) == "quartus_sta" } {
    set ::sta_flow 1
} elseif { $::TimeQuestInfo(nameofexecutable) == "quartus_fit" } {
    set ::fit_flow 1
} elseif { $::TimeQuestInfo(nameofexecutable) == "quartus_pow" } {
    set ::pow_flow 1
}

proc apply_sdc_reset_synchronizer {hier_path} {
    global ::fit_flow

    set tmp_keep [get_keepers -nowarn $hier_path]
    set tmp_pin [get_pins -nowarn ${hier_path}|clrn]
    if {[get_collection_size $tmp_pin] > 0} {
        if {$::fit_flow == 1} {
            set_multicycle_path -through $tmp_pin -to $tmp_keep -setup 7 -end
            set_multicycle_path -through $tmp_pin -to $tmp_keep -hold 6 -end
        } else {
            set_false_path -through $tmp_pin -to $tmp_keep
        }
    }
}

proc apply_sdc_data_synchronizer {hier_path} {
    global ::fit_flow

    set tmp_keep [get_keepers -nowarn $hier_path]
    set tmp_pin [get_pins -nowarn [list "${hier_path}|d" "${hier_path}|*data"]]
    if {[get_collection_size $tmp_pin] > 0} {
        if {$::fit_flow == 1} {
            set_multicycle_path -through $tmp_pin -to $tmp_keep -setup 7 -end
            set_multicycle_path -through $tmp_pin -to $tmp_keep -hold 6 -end
        } else {
            set_false_path -through $tmp_pin -to $tmp_keep
        }
    }
}

apply_sdc_data_synchronizer "unit_monitor|reset_tree_apb3|sync|din_s1"
apply_sdc_data_synchronizer "reset_tree_intf|sync|din_s1"

set_false_path -from [get_registers unit_monitor|reset_tree_apb3|reset_leaf*] -to [get_registers unit_monitor|*_skidbuf|skid.showahead_fifo|empty]
set_false_path -from [get_registers unit_monitor|reset_tree_apb3|reset_leaf*] -to [get_registers unit_monitor|*_skidbuf|skid.showahead_fifo|dc.dcfifo_inst|a*|*]


set fflaunch "*_skidbuf|skid.showahead_fifo|dc.dcfifo_inst*ff_launch[*]"
set ffmeta "*_skidbuf|skid.showahead_fifo|dc.dcfifo_inst*ff_meta[*]"
set fflaunch_keep [get_keepers -nowarn $fflaunch]
set ffmeta_keep [get_keepers -nowarn $ffmeta]
if {$::fit_flow == 1} {
    set_multicycle_path -from $fflaunch_keep -to $ffmeta_keep -setup 2 -end
    set_multicycle_path -from $fflaunch_keep -to $ffmeta_keep -hold 1 -end
} else {
    set_false_path -from $fflaunch_keep -to $ffmeta_keep
}
