module ed_synth_perf_monch1 (
		input  wire         clk,                //          clk.clk,     Clock Input
		input  wire         reset_n,            //      reset_n.reset_n, Reset Input
		input  wire         csr_clk,            //      csr_clk.clk,     Clock Input
		input  wire         csr_reset_n,        //  csr_reset_n.reset_n
		output wire         master_reset_reset, // master_reset.reset,   Reset Output
		input  wire         src_axi4_awready,   //     src_axi4.awready
		output wire         src_axi4_awvalid,   //             .awvalid
		output wire [6:0]   src_axi4_awid,      //             .awid
		output wire [43:0]  src_axi4_awaddr,    //             .awaddr
		output wire [7:0]   src_axi4_awlen,     //             .awlen
		output wire [2:0]   src_axi4_awsize,    //             .awsize
		output wire [1:0]   src_axi4_awburst,   //             .awburst
		output wire [3:0]   src_axi4_awqos,     //             .awqos
		output wire [0:0]   src_axi4_awlock,    //             .awlock
		output wire [0:0]   src_axi4_awuser,    //             .awuser
		output wire [2:0]   src_axi4_awprot,    //             .awprot
		output wire [3:0]   src_axi4_awcache,   //             .awcache
		input  wire         src_axi4_arready,   //             .arready
		output wire         src_axi4_arvalid,   //             .arvalid
		output wire [6:0]   src_axi4_arid,      //             .arid
		output wire [43:0]  src_axi4_araddr,    //             .araddr
		output wire [7:0]   src_axi4_arlen,     //             .arlen
		output wire [2:0]   src_axi4_arsize,    //             .arsize
		output wire [1:0]   src_axi4_arburst,   //             .arburst
		output wire [3:0]   src_axi4_arqos,     //             .arqos
		output wire [0:0]   src_axi4_arlock,    //             .arlock
		output wire [0:0]   src_axi4_aruser,    //             .aruser
		output wire [2:0]   src_axi4_arprot,    //             .arprot
		output wire [3:0]   src_axi4_arcache,   //             .arcache
		input  wire         src_axi4_wready,    //             .wready
		output wire         src_axi4_wvalid,    //             .wvalid
		output wire [255:0] src_axi4_wdata,     //             .wdata
		output wire [0:0]   src_axi4_wuser,     //             .wuser
		output wire [31:0]  src_axi4_wstrb,     //             .wstrb
		output wire         src_axi4_wlast,     //             .wlast
		output wire         src_axi4_bready,    //             .bready
		input  wire         src_axi4_bvalid,    //             .bvalid
		input  wire [6:0]   src_axi4_bid,       //             .bid
		input  wire [1:0]   src_axi4_bresp,     //             .bresp
		input  wire [0:0]   src_axi4_buser,     //             .buser
		output wire         src_axi4_rready,    //             .rready
		input  wire         src_axi4_rvalid,    //             .rvalid
		input  wire [6:0]   src_axi4_rid,       //             .rid
		input  wire [255:0] src_axi4_rdata,     //             .rdata
		input  wire [1:0]   src_axi4_rresp,     //             .rresp
		input  wire [0:0]   src_axi4_ruser,     //             .ruser
		input  wire         src_axi4_rlast,     //             .rlast
		output wire         sink_axi4_awready,  //    sink_axi4.awready
		input  wire         sink_axi4_awvalid,  //             .awvalid
		input  wire [6:0]   sink_axi4_awid,     //             .awid
		input  wire [43:0]  sink_axi4_awaddr,   //             .awaddr
		input  wire [7:0]   sink_axi4_awlen,    //             .awlen
		input  wire [2:0]   sink_axi4_awsize,   //             .awsize
		input  wire [1:0]   sink_axi4_awburst,  //             .awburst
		input  wire [3:0]   sink_axi4_awqos,    //             .awqos
		input  wire [0:0]   sink_axi4_awlock,   //             .awlock
		input  wire [0:0]   sink_axi4_awuser,   //             .awuser
		input  wire [2:0]   sink_axi4_awprot,   //             .awprot
		input  wire [3:0]   sink_axi4_awcache,  //             .awcache
		output wire         sink_axi4_arready,  //             .arready
		input  wire         sink_axi4_arvalid,  //             .arvalid
		input  wire [6:0]   sink_axi4_arid,     //             .arid
		input  wire [43:0]  sink_axi4_araddr,   //             .araddr
		input  wire [7:0]   sink_axi4_arlen,    //             .arlen
		input  wire [2:0]   sink_axi4_arsize,   //             .arsize
		input  wire [1:0]   sink_axi4_arburst,  //             .arburst
		input  wire [3:0]   sink_axi4_arqos,    //             .arqos
		input  wire [0:0]   sink_axi4_arlock,   //             .arlock
		input  wire [0:0]   sink_axi4_aruser,   //             .aruser
		input  wire [2:0]   sink_axi4_arprot,   //             .arprot
		input  wire [3:0]   sink_axi4_arcache,  //             .arcache
		output wire         sink_axi4_wready,   //             .wready
		input  wire         sink_axi4_wvalid,   //             .wvalid
		input  wire [255:0] sink_axi4_wdata,    //             .wdata
		input  wire [0:0]   sink_axi4_wuser,    //             .wuser
		input  wire [31:0]  sink_axi4_wstrb,    //             .wstrb
		input  wire         sink_axi4_wlast,    //             .wlast
		input  wire         sink_axi4_bready,   //             .bready
		output wire         sink_axi4_bvalid,   //             .bvalid
		output wire [6:0]   sink_axi4_bid,      //             .bid
		output wire [1:0]   sink_axi4_bresp,    //             .bresp
		output wire [0:0]   sink_axi4_buser,    //             .buser
		input  wire         sink_axi4_rready,   //             .rready
		output wire         sink_axi4_rvalid,   //             .rvalid
		output wire [6:0]   sink_axi4_rid,      //             .rid
		output wire [255:0] sink_axi4_rdata,    //             .rdata
		output wire [1:0]   sink_axi4_rresp,    //             .rresp
		output wire [0:0]   sink_axi4_ruser,    //             .ruser
		output wire         sink_axi4_rlast     //             .rlast
	);
endmodule

