`timescale 1ns / 100ps
module  golden_top (
    //Reset&Clock
        input  wire        clk_fpga_p  , // system clock, 100M
        input  wire        fpga_resetn , //system global reset
										   
    //leds                  
        output wire          fpga_led0	, 		//High: LED on						
        output wire          fpga_led1  ,
        output wire          fpga_led2	,
        output wire          fpga_led3  ,
        output wire          qsfpdd0_led0 , 		//High: LED on						
        output wire          qsfpdd0_led1 ,    
        output wire          qsfpdd1_led0 , 		//High: LED on						
        output wire          qsfpdd1_led1 , 
        output wire          qsfpdd800_led0 , 		//High: LED on						
        output wire          qsfpdd800_led1 , 
		
	//GPIO between MAX10 and FPGA
	    inout  wire		    max_fpga_gpio0  ,
		inout  wire		    max_fpga_gpio1  ,
		inout  wire		    max_fpga_gpio2  ,
		inout  wire		    max_fpga_gpio3  ,
		inout  wire		    max_fpga_gpio4  ,
		inout  wire		    max_fpga_gpio5  ,
		inout  wire		    max_fpga_gpio6  ,
		inout  wire		    max_fpga_gpio7  ,
		
	//qsfp control signals
        output wire          qsfpdd800_reset_n,
        output wire          qsfpdd800_modsel_n,
        input  wire          qsfpdd800_modprs_n,
        output wire          qsfpdd800_lpmode,
        input  wire          qsfpdd800_int_n, 
		output wire          qsfpdd800_epps,
        output wire          qsfpdd0_reset_n,
        output wire          qsfpdd0_modsel_n,
        input  wire          qsfpdd0_modprs_n,
        output wire          qsfpdd0_lpmode,
        input  wire          qsfpdd0_int_n,  
        output wire          qsfpdd1_reset_n,
        output wire          qsfpdd1_modsel_n,
        input  wire          qsfpdd1_modprs_n,
        output wire          qsfpdd1_lpmode,
        input  wire          qsfpdd1_int_n,	   
        		
    //I2C interfaces
        inout  wire		     fmc_scl , 
        inout  wire		     fmc_sda , 
        inout  wire		     cxl_scl , 
        inout  wire		     cxl_sda ,    
        inout  wire		     qsfp_scl , 
        inout  wire		     qsfp_sda , 
        inout  wire		     rdimm_i2c_scl , 
        inout  wire		     rdimm_i2c_sda ,
  
	//si5518 spi
        output  wire		 si5518_sclk , 
        output  wire		 si5518_cs_n ,
        output  wire		 si5518_mosi ,
        input  wire          si5518_miso ,	
		
    //other GPIO
        output wire          si5518_rstn ,
        input wire           si5392_lolb ,
		inout  wire          si5518_fpga_gpio0,
		inout  wire          si5518_fpga_gpio1,
		inout  wire          si5518_fpga_gpio2,
	//The below two not for revA
		output wire          sdi_clk148_5m_up,
        output wire          sdi_clk148_5m_down
	
	//1PPS/ToD
	    output wire         pps_fpga_clkout,
	    input  wire         tod_master_clk_125m_p,
		output wire         pps_scope2_clkout,
		input  wire         pps_scope1_clkin,
		output wire         sel_pps_inout,
		input  wire         pps_fpga_clkin,
		output wire         fpga_10mhz_clkout,
		input  wire         sample_clkin_312m_p,
	
    //FMC
	    input  wire         refclk_fgt12Ach2_p, // fmc reference clock 156.25MHz      
        input  wire [15:0]  fmc_rx_p      , 
        input  wire [15:0]  fmc_rx_n      , 
        output wire [15:0]  fmc_tx_p      , 
        output wire [15:0]  fmc_tx_n      ,
        //COMS Interface		      
        //input             falan0             , // input,  lvds/cmos loopback test is not supported, input clock from loopback card
        //input             falap0             , // input,  lvds/cmos loopback test is not supported, input clock from loopback card
        //output            falan1             , // output, lvds/cmos loopback test is not supported, output clock to loopback card
        //output            falap1             , // output, lvds/cmos loopback test is not supported, output clock to loopback card      
        input  wire         falan2             ,
        input  wire         falap2             ,
        output wire         falan3             ,
        output wire         falap3             ,
        input  wire         falan4             ,
        input  wire         falap4             ,
        input  wire         falan5             ,
        input  wire         falap5             ,
        output wire         falan6             ,
        output wire         falap6             ,
        input  wire         falan7             ,
        input  wire         falap7             ,
        output wire         falan8             ,
        output wire         falap8             ,
        input  wire         falan9             ,
        input  wire         falap9             ,
        output wire         falan10            ,
        output wire         falap10            ,
        input  wire         falan11            ,
        input  wire         falap11            ,
        output wire         falan12            ,
        output wire         falap12            ,
        input  wire         falan13            ,
        input  wire         falap13            ,
        output wire         falan14            ,
        output wire         falap14            ,
        input  wire         falan15            ,
        input  wire         falap15            ,
        output wire         falan16            ,
        output wire         falap16            ,
        input  wire         falan17            ,
        input  wire         falap17            ,
        output wire         falan18            ,
        output wire         falap18            ,
        input  wire         falan19            ,
        input  wire         falap19            ,
        output wire         falan20            ,
        output wire         falap20            ,
        input  wire         falan21            ,
        input  wire         falap21            ,
        output wire         falan22            ,
        output wire         falap22            ,
        input  wire         falan23            ,
        input  wire         falap23            ,
        input  wire         falan24            ,
        input  wire         falap24            ,
        output wire         falan25            ,
        output wire         falap25            ,
        input  wire         falan26            ,
        input  wire         falap26            ,
        output wire         falan27            ,
        output wire         falap27            ,
        input  wire         falan28            ,
        input  wire         falap28            ,
        output wire         falan29            ,
        output wire         falap29            ,
        input  wire         falan30            ,
        input  wire         falap30            ,
        output wire         falan31            ,
        output wire         falap31            ,
        output wire         falan32            ,
        output wire         falap32            ,
        output wire         falan33            ,
        output wire         falap33            ,
			
	//QSFPDD0/1
		input  wire        refclk_fgt13Ach5_p    , // QSFPDD1 reference clock 156.25MHz 
		input  wire        refclk_fgt13Cch5_p    , // QSFPDD0 reference clock 156.25MHz 
		input  wire [7:0]  qsfpdd0_rx_p          , // QSFPDD #0 RX P
        input  wire [7:0]  qsfpdd0_rx_n          , // QSFPDD #0 RX N
        output wire [7:0]  qsfpdd0_tx_p          , // QSFPDD #0 TX P
        output wire [7:0]  qsfpdd0_tx_n          , // QSFPDD #0 TX N
        input  wire [7:0]  qsfpdd1_rx_p          , // QSFPDD #1 RX P
        input  wire [7:0]  qsfpdd1_rx_n          , // QSFPDD #1 RX N
        output wire [7:0]  qsfpdd1_tx_p          , // QSFPDD #1 TX P
        output wire [7:0]  qsfpdd1_tx_n          , // QSFPDD #1 TX N
	
    //QSFPDD800
		input  wire        in_refclk_fgt_13C,
        input  wire        in_refclk_fht_13C,
		input  wire        in_refclk_fgt_13A,
        input  wire        in_refclk_fht_13A,
		input  wire [7:0]  qsfpdd800_rx_p , 
        input  wire [7:0]  qsfpdd800_rx_n , 
        output wire [7:0]  qsfpdd800_tx_p , 
        output wire [7:0]  qsfpdd800_tx_n ,	
		
	//CXL
        input  wire        fpga_cxl_perstn     , // CXL_PERSTN
        output wire        fpga_pcie1_perst0_n , // for RP only
        input  wire        refclk_cxl_14c_ch0_p, // CXL reference clock #0
        input  wire        refclk_cxl_14c_ch1_p, // CXL reference clock #1

        input  wire [15:0] cxl_rx_p                , // CXL RX channels 
        input  wire [15:0] cxl_rx_n                , // CXL RX channels 
        output wire [15:0] cxl_tx_p                , // CXL TX channels
        output wire [15:0] cxl_tx_n                , // CXL TX channels	
		
	//FABRIC DDR5
        input  wire        ref_clk_0_clk,                //        ref_clk_0.clk
		output wire        emif_ph2_0_mem_0_mem_ck_t,    // emif_ph2_0_mem_0.mem_ck_t
		output wire        emif_ph2_0_mem_0_mem_ck_c,    //                 .mem_ck_c
		output wire        emif_ph2_0_mem_0_mem_reset_n, //                 .mem_reset_n
		output wire        emif_ph2_0_mem_0_mem_cs_n,    //                 .mem_cs_n
		output wire [12:0] emif_ph2_0_mem_0_mem_ca,      //                 .mem_ca
		inout  wire [39:0] emif_ph2_0_mem_0_mem_dq,      //                 .mem_dq
		inout  wire [4:0]  emif_ph2_0_mem_0_mem_dqs_t,   //                 .mem_dqs_t
		inout  wire [4:0]  emif_ph2_0_mem_0_mem_dqs_c,   //                 .mem_dqs_c
		output wire [4:0]  emif_ph2_0_mem_0_mem_dm_n,    //                 .mem_dm_n
		input  wire        emif_ph2_0_mem_0_mem_alert_n, //                 .mem_alert_n
		input  wire        emif_ph2_0_oct_0_oct_rzqin,   // emif_ph2_0_oct_0.oct_rzqin	
	
	//HPS DDR5
	    input  wire        hps_ref_clk_0_clk,                //        ref_clk_0.clk
        output wire        hps_emif_ph2_0_mem_0_mem_ck_t,    // hps_emif_ph2_0_mem_0.mem_ck_t
		output wire        hps_emif_ph2_0_mem_0_mem_ck_c,    //                 .mem_ck_c
		output wire        hps_emif_ph2_0_mem_0_mem_reset_n, //                 .mem_reset_n
		output wire        hps_emif_ph2_0_mem_0_mem_cs_n,    //                 .mem_cs_n
		output wire [12:0] hps_emif_ph2_0_mem_0_mem_ca,      //                 .mem_ca
		inout  wire [39:0] hps_emif_ph2_0_mem_0_mem_dq,      //                 .mem_dq
		inout  wire [4:0]  hps_emif_ph2_0_mem_0_mem_dqs_t,   //                 .mem_dqs_t
		inout  wire [4:0]  hps_emif_ph2_0_mem_0_mem_dqs_c,   //                 .mem_dqs_c
		output wire [4:0]  hps_emif_ph2_0_mem_0_mem_dm_n,    //                 .mem_dm_n
		input  wire        hps_emif_ph2_0_mem_0_mem_alert_n, //                 .mem_alert_n
		input  wire        hps_emif_ph2_0_oct_0_oct_rzqin,   // emif_ph2_0_oct_0.oct_rzqin		

		
	//LPDDR5
        input  wire        lpddr5_ref_clk_0_clk,                //        ref_clk_0.clk
		output wire        lpddr5_emif_ph2_0_mem_0_mem_ck_t,    // lpddr5_emif_ph2_0_mem_0.mem_ck_t
		output wire        lpddr5_emif_ph2_0_mem_0_mem_ck_c,    //                 .mem_ck_c
		output wire        lpddr5_emif_ph2_0_mem_0_mem_reset_n, //                 .mem_reset_n
		output wire        lpddr5_emif_ph2_0_mem_0_mem_cs,      //                 .mem_cs
		output wire [6:0]  lpddr5_emif_ph2_0_mem_0_mem_ca,      //                 .mem_ca
		inout  wire [15:0] lpddr5_emif_ph2_0_mem_0_mem_dq,      //                 .mem_dq
		output wire [1:0]  lpddr5_emif_ph2_0_mem_0_mem_wck_t,   //                 .mem_wck_t
		output wire [1:0]  lpddr5_emif_ph2_0_mem_0_mem_wck_c,   //                 .mem_wck_c
		inout  wire [1:0]  lpddr5_emif_ph2_0_mem_0_mem_rdqs_t,  //                 .mem_rdqs_t
		inout  wire [1:0]  lpddr5_emif_ph2_0_mem_0_mem_rdqs_c,  //                 .mem_rdqs_c
		inout  wire [1:0]  lpddr5_emif_ph2_0_mem_0_mem_dmi,     //                 .mem_dmi
		output wire        lpddr5_emif_ph2_0_mem_1_mem_ck_t,    // lpddr5_emif_ph2_0_mem_1.mem_ck_t
		output wire        lpddr5_emif_ph2_0_mem_1_mem_ck_c,    //                 .mem_ck_c
		output wire        lpddr5_emif_ph2_0_mem_1_mem_cs,      //                 .mem_cs
		output wire [6:0]  lpddr5_emif_ph2_0_mem_1_mem_ca,      //                 .mem_ca
		inout  wire [15:0] lpddr5_emif_ph2_0_mem_1_mem_dq,      //                 .mem_dq
		output wire [1:0]  lpddr5_emif_ph2_0_mem_1_mem_wck_t,   //                 .mem_wck_t
		output wire [1:0]  lpddr5_emif_ph2_0_mem_1_mem_wck_c,   //                 .mem_wck_c
		inout  wire [1:0]  lpddr5_emif_ph2_0_mem_1_mem_rdqs_t,  //                 .mem_rdqs_t
		inout  wire [1:0]  lpddr5_emif_ph2_0_mem_1_mem_rdqs_c,  //                 .mem_rdqs_c
		inout  wire [1:0]  lpddr5_emif_ph2_0_mem_1_mem_dmi,     //                 .mem_dmi
		input  wire        lpddr5_emif_ph2_0_oct_0_oct_rzqin,   // emif_ph2_0_oct_0.oct_rzqin
		input  wire        lpddr5_emif_ph2_0_oct_1_oct_rzqin,   // emif_ph2_0_oct_1.oct_rzqin
		
	//HBM2E_TOP
	    input  wire       top_core_pll_refclk_clk,
        input  wire       top_uibpll_refclk_clk,   
        input  wire       top_noc_clk_ctrl_refclk_clk,
        input  wire       top_hbm_cattrip_virtual,
        input  wire [2:0] top_hbm_temp_virtual,
		
	//HBM2E_BOTTOM
	    input  wire       bottom_core_pll_refclk_clk,
        input  wire       bottom_uibpll_refclk_clk,   
        input  wire       bottom_noc_clk_ctrl_refclk_clk,
        input  wire       bottom_hbm_cattrip_virtual,
        input  wire [2:0] bottom_hbm_temp_virtual
  );
  